/*
 * Bittorrent Client using Qt4 and libtorrent.
 * Copyright (C) 2006  Christophe Dumez
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Contact : chris@qbittorrent.org
 */

#ifndef DELETETHREAD_H
#define DELETETHREAD_H

#include <QThread>

#include "misc.h"

class deleteThread : public QThread {
  Q_OBJECT

  private:
    QString path;

  public :
    deleteThread(QString _path): path(_path){
      start();
    }

    ~deleteThread(){
      wait();
    }

  signals:
    void deletionFinished(deleteThread*) const;

  private:
    void run(){
      misc::removePath(path);
      emit deletionFinished(this);
    }
};

#endif
